unit QuestionEditor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, Buttons, ExtCtrls, shellApi, Unit1, ImgList;

type
  TfrmMain = class(TForm)
    Label1: TLabel;
    lblNumber: TLabel;
    sbtnRight: TSpeedButton;
    sbtnLeft: TSpeedButton;
    Gb: TGroupBox;
    EditQuestion: TEdit;
    rb1: TRadioButton;
    rb2: TRadioButton;
    rb3: TRadioButton;
    Editv1: TEdit;
    Editv2: TEdit;
    Editv3: TEdit;
    MainMenu1: TMainMenu;
    mnuFile: TMenuItem;
    mnuExit: TMenuItem;
    mnuHelp: TMenuItem;
    mnuAbout: TMenuItem;
    mnuSave: TMenuItem;
    mnuOpen: TMenuItem;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    Button2: TButton;
    Button3: TButton;
    mnuHelpF1: TMenuItem;
    lblS1: TLabel;
    lblS2: TLabel;
    lblS3: TLabel;
    ImageList1: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure sbtnRightClick(Sender: TObject);
    procedure sbtnLeftClick(Sender: TObject);
    procedure mnuSaveClick(Sender: TObject);
    procedure mnuOpenClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure mnuHelpF1Click(Sender: TObject);
    procedure mnuAboutClick(Sender: TObject);
    procedure mnuExitClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type
     TList=array[1..40] of string;
     TCorrect=array[1..40] of integer;
     string20=string[70];
     TQuestion=record
                 qqq:string20;
                 vv1,vv2,vv3:string20;
                 ccc:integer
     end;
var
  frmMain: TfrmMain;
  n,s1,s2,s3,p1,p2,p3:integer;
  qq,v1,v2,v3:TList;
  c:TCorrect;
  Test:array[1..40] of TQuestion;
  Changed:boolean;
  f:File of TQuestion;
  title:string;
implementation

{$R *.dfm}

Procedure GetFileName(h:string; var fn:string);
  var i,k,i0:integer;
  begin
    fn:='';i0:=0;
    k:=length(h);
    for i:=1 to k do
      if (h[i]='/')or(h[i]='\')
        then i0:=i;
    for i:=i0+1 to k do
      fn:=fn+h[i];
  end;

Procedure GetPathName(h:string; var fn:string);
  var i,k,i0:integer;
  begin
    fn:='';i0:=0;
    k:=length(h);
    for i:=1 to k do
      if (h[i]='/')or(h[i]='\')
        then i0:=i;
    for i:=1 to i0-1 do
      fn:=fn+h[i];
  end;

Procedure SaveQuestions;
  var h:string;
      i:integer;
  begin
    if frmmain.SaveDialog.Execute
      then
        begin
          h:=frmMain.SaveDialog.FileName; //   
          AssignFile(f,h);
          rewrite(f);
          for i:=1 to 40 do
            begin
              with Test[i] do
                begin
                  qqq:=qq[i];
                  vv1:=v1[i];
                  vv2:=v2[i];
                  vv3:=v3[i];
                  ccc:=c[i]
                end;
              write(f,Test[i])
            end;
          closeFile(f);
          Getfilename(h,h);
          frmMain.Caption:=h+' - '+title;
          //frmMAin.lblNumber.Caption:=h;
        end
  end;

procedure OpenQuestions;
  var h:string;
      i:integer;
  begin
    if frmMain.OpenDialog.Execute
      then
        begin
          h:=frmMain.OpenDialog.FileName;
          assignFile(f,h);
          reset(f);
          for i:=1 to 40 do
            begin
              read(f,Test[i]);
              with Test[i] do
                begin
                  qq[i]:=qqq;
                  v1[i]:=vv1;
                  v2[i]:=vv2;
                  v3[i]:=vv3;
                  c[i]:=ccc
                end;
            end;
          close(f);
        end;
      Getfilename(h,h);
      if h<>'' then frmMain.Caption:=h+' - '+title;
      n:=1;
      frmMain.lblNumber.Caption:='1';
      frmMain.EditQuestion.Text:=qq[n];
      frmMain.Editv1.Text:=v1[n];
      frmMain.Editv2.Text:=v2[n];
      frmMain.Editv3.Text:=v3[n];
      if c[n]=1 then frmMain.rb1.Checked:=true;
      if c[n]=2 then frmMain.rb2.Checked:=true;
      if c[n]=3 then frmMain.rb3.Checked:=true;
  end;

Procedure CountChoices;
    var i:integer;
        h,hh:string;
  begin
    s1:=0; s2:=0; s3:=0; p1:=0; p2:=0; p3:=0;
    for i:=1 to 20 do
      begin
        if c[i]=1 then inc(s1);
        if c[i]=2 then inc(s2);
        if c[i]=3 then inc(s3);
      end;
    for i:=21 to 40 do
      begin
        if c[i]=1 then inc(p1);
        if c[i]=2 then inc(p2);
        if c[i]=3 then inc(p3);
      end;
    str(s1,h);str(p1,hh); frmMain.lblS1.Caption:=h+'/'+hh;
    str(s2,h); str(p2,hh); frmMain.lblS2.Caption:=h+'/'+hh;
    str(s3,h); str(p3,hh); frmMain.lblS3.Caption:=h+'/'+hh;
  end;

procedure TfrmMain.FormCreate(Sender: TObject);
  var hhh:string;
begin
  n:=1; //   
  s1:=0; s2:=0; s3:=0; p1:=0; p2:=0; p3:=0;//  
  title:='    " "';
  hhh:=application.ExeName;
  getPathName(hhh,hhh);
  OpenDialog.InitialDir:=hhh;
  {qq[1]:='      ?';
  v1[1]:='';
  v2[1]:='';
  v3[1]:='';
  c[1]:=2;
  i:=2; //  
  qq[i]:='  ';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=3;
  i:=3; //  
  qq[i]:=',    ';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=1;
  i:=4; //  
  qq[i]:='   ...';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=3;
    i:=5; //  
  qq[i]:='   ?';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=2;
    i:=6; //  
  qq[i]:='  " "';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=1;
    i:=7; //  
  qq[i]:='   ?';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=3;
    i:=8; //  
  qq[i]:='    ?';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=2;
    i:=9; //  
  qq[i]:='    ';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=3;
    i:=10; //  
  qq[i]:='  -  ?';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=1;
    i:=11; //  
  qq[i]:='    ...';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=2;
    i:=12; //  
  qq[i]:=',    ';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=3;
    i:=13; //  
  qq[i]:='  ';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=1;
    i:=14; //  
  qq[i]:='    ?';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=2;
    i:=15; //  
  qq[i]:='    ';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=1;
    i:=16; //  
  qq[i]:='     ';
  v1[i]:='ϸ';
  v2[i]:='';
  v3[i]:='';
  c[i]:=3;
    i:=17; //  
  qq[i]:='     ?';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=2;
    i:=18; //  
  qq[i]:=' -   ';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=3;
    i:=19; //  
  qq[i]:='    ';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=1;
    i:=20; //  
  qq[i]:='      ?';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=2;
    i:=21; //  
  qq[i]:=',     ';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=1;
    i:=22; //  
  qq[i]:='  ';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=3;
    i:=23; //  
  qq[i]:='   ...';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=2;
    i:=24; //  
  qq[i]:='   ';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=1;
    i:=25; //  
  qq[i]:='  "  "';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=3;
    i:=26; //  
  qq[i]:='   ';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=2;
    i:=27; //  
  qq[i]:='  "17  " ';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=1;
    i:=28; //  
  qq[i]:='     I';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=1;
    i:=29; //  
  qq[i]:='  ?';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=2;
      i:=30; //  
  qq[i]:='     ...';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=3;
    i:=31; //  
  qq[i]:=' ';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=2;
      i:=32; //  
  qq[i]:='    ?';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=1;
    i:=33; //  
  qq[i]:='   ';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=3;
    i:=34; //  
  qq[i]:=' ';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=2;
    i:=35; //  
  qq[i]:='   ';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=1;
    i:=36; //  
  qq[i]:='   ';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=3;
    i:=37; //  
  qq[i]:='    ';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=2;
    i:=38; //  
  qq[i]:='  ';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=1;
    i:=39; //  
  qq[i]:='     ';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=3;
    i:=40; //  
  qq[i]:='  " "';
  v1[i]:='';
  v2[i]:='';
  v3[i]:='';
  c[i]:=2;}
end;

procedure TfrmMain.sbtnRightClick(Sender: TObject);
  var h:string;
begin
  qq[n]:=EditQuestion.Text;
  v1[n]:=Editv1.Text;
  v2[n]:=Editv2.Text;
  v3[n]:=Editv3.Text;
  if rb1.Checked then c[n]:=1;
  if rb2.Checked then c[n]:=2;
  if rb3.Checked then c[n]:=3;
  inc(n);
  if n>40 then n:=40;
  str(n,h);
  lblNumber.Caption:=h;
  EditQuestion.Text:=qq[n];
  Editv1.Text:=v1[n];
  Editv2.Text:=v2[n];
  Editv3.Text:=v3[n];
  case c[n] of
    1: rb1.Checked:=true;
    2: rb2.Checked:=true;
    3: rb3.Checked:=true;
  end;
  CountChoices
end;

procedure TfrmMain.sbtnLeftClick(Sender: TObject);
  var h:string;
begin
  qq[n]:=EditQuestion.Text;
  v1[n]:=Editv1.Text;
  v2[n]:=Editv2.Text;
  v3[n]:=Editv3.Text;
  if rb1.Checked then c[n]:=1;
  if rb2.Checked then c[n]:=2;
  if rb3.Checked then c[n]:=3;
  dec(n);
  if n<1 then n:=1;
  str(n,h);
  lblNumber.Caption:=h;
  EditQuestion.Text:=qq[n];
  Editv1.Text:=v1[n];
  Editv2.Text:=v2[n];
  Editv3.Text:=v3[n];
  case c[n] of
    1: rb1.Checked:=true;
    2: rb2.Checked:=true;
    3: rb3.Checked:=true;
  end;
  CountChoices
end;

procedure TfrmMain.mnuSaveClick(Sender: TObject);
begin
  SaveQuestions
end;

procedure TfrmMain.mnuOpenClick(Sender: TObject);
begin
  OpenQuestions;
  CountChoices
end;

procedure TfrmMain.Button2Click(Sender: TObject);
begin
  qq[n]:='';
  v1[n]:='';
  v2[n]:='';
  v3[n]:='';
  rb1.Checked:=false;
  rb2.Checked:=false;
  rb3.Checked:=false;
  //        
  EditQuestion.Text:=qq[n];
  Editv1.Text:=v1[n];
  Editv2.Text:=v2[n];
  Editv3.Text:=v3[n];
  rb1.Checked:=false;
  rb2.Checked:=false;
  rb2.Checked:=false;
  CountChoices
end;

procedure TfrmMain.Button3Click(Sender: TObject);
  var i:integer;
begin
  for i:=1 to 40 do
    begin
      qq[i]:='';
      v1[i]:='';
      v2[i]:='';
      v3[i]:='';
      c[i]:=0;
    end;
  n:=1;
  frmMain.EditQuestion.Text:=qq[n];
  frmMain.Editv1.Text:=v1[n];
  frmMain.Editv2.Text:=v2[n];
  frmMain.Editv3.Text:=v3[n];
  frmMain.rb1.Checked:=false;
  frmMain.rb2.Checked:=false;
  frmMain.rb3.Checked:=false;
  lblNumber.Caption:='1';
  frmMain.Caption:=title;
  s1:=0; s2:=0; s3:=0; p1:=0; p2:=0; p3:=0;
  lblS1.Caption:='0/0';
  lblS2.Caption:='0/0';
  lblS3.Caption:='0/0';
end;

procedure TfrmMain.mnuHelpF1Click(Sender: TObject);
begin
  ShellExecute(handle, 'Open', 'Help.chm', '', '', 1)
end;

procedure TfrmMain.mnuAboutClick(Sender: TObject);
begin
   frmAbout.Visible:=true
end;

procedure TfrmMain.mnuExitClick(Sender: TObject);
begin
  application.Terminate
end;

end.
